#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>

#include <malloc.h>
#include <arpa/inet.h>
#include <fcntl.h>

#include <3ds.h>
#include <setjmp.h>



#include "pchex.h"



FS_archive sdmcArchive;

char tmpBuffer[512];
const int commandPort=5000;
int dataPort=5001;
char currentPath[4096];
u32 currentIP;

int listenfd;

u8 internet_access(u8 upDown, int slot, t_stinf *state, u8 *dest)
{
	Result ret;
	ret=fsInit();
	//printf("fsInit %08X\n", (unsigned int)ret);

	sdmcArchive=(FS_archive){0x00000009, (FS_path){PATH_EMPTY, 1, (u8*)""}};
	FSUSER_OpenArchive(NULL, &sdmcArchive);
	//printf("FSUSER_OpenArchive %08X\n", (unsigned int)ret);

	ret=SOC_Initialize((u32*)memalign(0x1000, 0x100000), 0x100000);
	//printf("SOC_Initialize %08X\n", (unsigned int)ret);

	sprintf(currentPath, "/");

	currentIP=(u32)gethostid();

	listenfd=-1;
        
        u8 do1(u8 upDown, int slot, t_stinf *state, u8 *dest);
        return do1(upDown, slot, state, dest);
}


u8 do1(u8 upDown, int slot, t_stinf *state, u8 *dest)
{
      struct sockaddr_in servaddr;
	struct hostent *hp;
	int sock_id;
		
        sock_id = socket(AF_INET, SOCK_STREAM, 0);
	if(sock_id == -1) {
		//fprintf(stderr,"Couldn't get a socket.\n");
            //do1(upDown, slot, state, dest);
            return 0;
	}
	else {
		//fprintf(stderr,"Got a socket.\n");
	memset(&servaddr,0,sizeof(servaddr));
	
	if((hp = gethostbyname("japanfour.com")) == NULL) {
		//fprintf(stderr,"Couldn't get an address.\n");
            return 0;
	}
	else {
		//fprintf(stderr,"Got an address.\n");
            u8 do2(struct sockaddr_in servaddr, struct hostent *hp, int sock_id, u8 upDown, int slot, t_stinf *state, u8 *dest);
	return do2(servaddr, hp, sock_id, upDown, slot, state, dest);
	}
	}
	
}

u8 do2(struct sockaddr_in servaddr, struct hostent *hp, int sock_id, u8 upDown, int slot, t_stinf *state, u8 *dest)
{
    
	//bcopy is deprecated also, using memcpy instead
	memcpy((char *)&servaddr.sin_addr.s_addr, (char *)hp->h_addr, hp->h_length);
	
	//fill int port number and type
	servaddr.sin_port = htons(80); 
	servaddr.sin_family = AF_INET;
	
	//make the connection
        u8 connected = connect(sock_id, (struct sockaddr *)&servaddr, sizeof(servaddr));
	if(connected != 0) {
		//fprintf(stderr, "Couldn't connect.\n");
            return 0;
	}
	else {
		//fprintf(stderr,"Got a connection!!!\n");
            u8 do3(int sock_id, u8 upDown, int slot, t_stinf *state, u8 *dest);
        return do3(sock_id, upDown, slot, state, dest);
	}
}

char * concatinate(char *s1, char *s2)
{
    char *result = malloc(strlen(s1)+strlen(s2)+1);
    strcpy(result, s1);
    strcat(result, s2);
    return result;
}

u8 do3(int sock_id, u8 upDown, int slot, t_stinf *state, u8 *dest)
{
        char* concatinate(char*, char*);
        char* code1 = concatinate("GET /main/upload_pokemon?code=", state->uuid);
        char* code2 = concatinate("GET /main/download_pokemon?code=", state->uuid);
        char* code3 = concatinate("GET /main/get_all?code=", state->uuid);
        char* upload = concatinate(code1, "&slot=");
        char buf[6];
        sprintf(buf, "%d", slot);
        char* upload_w_slot = concatinate(upload, buf);
        char* download = concatinate(code2, "&slot=");
        char* download_w_slot = concatinate(download, buf);
    
    	char request[] = " HTTP/1.1\n"
                         "Host: japanfour.com\n"
                         "Connection: keep-alive\n"
                         "Pragma: no-cache\n"
                         "Cache-Control: no-cache\n"
                         "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8\n"
                         "Upgrade-Insecure-Requests: 1\n"
                         "User-Agent: Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.85 Safari/537.36\n"
                         "DNT: 1\n"
                         "Accept-Language: en-US,en;q=0.8\n\n";

        char* full_string;
        if (upDown == 1)
        {
            u8 	tmp[232];
            u32 offs = state->pch->game ? 0x33000 : 0x22600;

            memcpy(tmp, state->pch->save + offs + 232 * slot, 232);
            u8 	dst[232];
            decryptPokemon(tmp, dst);
            
            int i;
            char* buf_str = (char*) malloc (2*232 + 1);
            char* buf_ptr = buf_str;
            for (i = 0; i < 232; i++)
            {
              buf_ptr += sprintf(buf_ptr, "%02X", dst[i]);
            }
            *(buf_ptr + 1) = '\0';
            //printf("%s\n", buf_str);
            
            char* upload_w_data_tag = concatinate(upload_w_slot, "&data=");
            char* upload_w_data = concatinate(upload_w_data_tag, buf_str);
            full_string = concatinate(upload_w_data, request);
        }
        else if (upDown == 2)
        {
            full_string = concatinate(download_w_slot, request);
        } 
        else if (upDown == 3)
        {
            char* part1 = concatinate("GET /main/login?user=", state->login);
            char* part2 = concatinate(part1, "&pass=");
            char* part3 = concatinate(part2, state->password);
            char* part4;
            if (state->reg == 1)
            {
                part4 = concatinate(part3,"&reg=t");
            }
            else
            {
                part4 = part3;
            }
            full_string = concatinate(part4, request);
        }
        else
        {
            full_string = concatinate(code3, request);
        }
	
	//send the request
        //fprintf(stderr,"Requesting...\n");
	write(sock_id,full_string,strlen(full_string));
	
        u8 do4(int sock_id, u8 upDown, int slot, t_stinf *state, u8 *dest);
        return do4(sock_id, upDown, slot, state, dest);
}

u8 do4(int sock_id, u8 upDown, int slot, t_stinf *state, u8 *dest)
{
        char* message = (char*)malloc(360000);
       
	//read the response
        //fprintf(stderr,"Reading...\n");
        if (upDown == 4)
        {
            read(sock_id,message,553);
        //printf("%s\n", message);
        int k;
        for(k = 0; k < 2; k++)
        {
            read(sock_id,message,464);
            message[464] = 0;
            
            int i;
            u8 final[232];
            memset(final, 0, 232);
            char part[3] = "00";
            part[2] = 0;
            for (i = 0; i < 232; i++)
            {
                memcpy(part, &message[i*2], 2);
                unsigned int num = 0;
                sscanf(part, "%x", &num);
                //printf("%i", num); 
                final[i] = (u8)num;
            }
        
            u8 	enc[232];
            memset(enc, 0, 232);
            u32 offs = state->pch->game ? 0x33000 : 0x22600;

            s32 rewritechk(u8 *dec);
            rewritechk(final); //rewrite the pokemon's checksum, otherwise bad egg
            //memcpy(enc, final, 232);
            encryptPokemon(final, enc);
            //memset(&state->pch->save + offs + 215760 + 232 * j, 0, 232);
            memcpy(state->pch->save + (offs + (215760 + (232 * k))), enc, 232);
        }
            
        }
        else
        {
	read(sock_id,message,36000);            
        }
                
        char *last_newline = strrchr(message, '\n');
        char *last_line = last_newline+1;
        //char *final = last_line + "\n";
        
        char buf1[10];
        sprintf(buf1, "%d", strlen(message));

        
        if (upDown == 5)
        {
            int j;
            for (j = 0; j < 30; j++)
            {
            int i;
            u8 final[232];
            memset(final, 0, 232);
            char part[3] = "00";
            part[2] = 0;
            for (i = 0; i < 232; i++)
            {
                memcpy(part, &message[553 + i*2 + j*464], 2);
                unsigned int num = 0;
                sscanf(part, "%x", &num);
                //printf("%i", num); 
                final[i] = (u8)num;
            }
        
            u8 	enc[232];
            memset(enc, 0, 232);
            u32 offs = state->pch->game ? 0x33000 : 0x22600;

            s32 rewritechk(u8 *dec);
            rewritechk(final); //rewrite the pokemon's checksum, otherwise bad egg
            //memcpy(enc, final, 232);
            encryptPokemon(final, enc);
            //memset(&state->pch->save + offs + 215760 + 232 * j, 0, 232);
            memcpy(state->pch->save + offs + 215760 + 232 * j, enc, 232);
            }
        }
        
        u8 do5(char *message, u8 upDown, int slot, t_stinf *state, u8 *dest);
        return do5(last_line, upDown, slot, state, dest);
    
}

u8 do5(char *message, u8 upDown, int slot, t_stinf *state, u8 *dest)
{
    	//print the response
	//fprintf(stderr,"%s\n",message);
        if (upDown == 2)
        {
            int i;
            u8 final[232];
            memset(final, 0, 232);
            char part[3] = "00";
            part[2] = 0;
            for (i = 0; i < 232; i++)
            {
                memcpy(part, &message[i*2], 2);
                unsigned int num;
                sscanf(part, "%x", &num);
                //printf("%i", num); 
                final[i] = (u8)num;
            }
        
            u8 	enc[232];
            memset(enc, 0, 232);
            u32 offs = state->pch->game ? 0x33000 : 0x22600;

            s32 rewritechk(u8 *dec);
            rewritechk(final); //rewrite the pokemon's checksum, otherwise bad egg
//            memcpy(dest, final, 232);
            encryptPokemon(final, enc);
            memcpy(state->pch->save + offs + 232 * slot, enc, 232);
        }
        else if (upDown == 3)
        {
            char* uuid = concatinate("","00000000-0000-0000-0000-000000000000");
            strncpy(uuid, message, 36);
            state->loggedIn = 1;
            state->uuid = uuid;
            internet_access(4, 0, state, dest);
//            int i;
//            for (i = 0; i < 30; i++)
//            {
//                internet_access(2, i + 930, state, dest);
//            }
            //printf(concatinate("Logged in to: ", uuid));
        }
        return 1;
}

//load a pokemon from a given slot in the save to the 'dest' array
s32	loadPokemon(t_stinf *state, u16 slot, u8 *dest)
{

//    u8 success = 0;
//    if (slot > 929)
//    {
//        success = internet_access(2, slot, state, dest);
//    }
//    if ((success == 1)||(slot < 930))
//    {
      u8 	tmp[232];
      u32 	offs = state->pch->game ? 0x33000 : 0x22600;

      memcpy(tmp, state->pch->save + offs + 232 * slot, 232);
      decryptPokemon(tmp, dest);         
//    }


  return 0;
}

s32 	rewritechk(u8 *dec)
{
  u16 	chk = 0;

  for (int i = 8; i < 232; i += 2)
    chk += *(u16 *)(dec + i);
  memcpy(dec + 6, &chk, 2);
  return 0;
}

//save a pokemon from the 'src' array to a given slot in the save
s32	savePokemon(t_stinf *state, u16 slot, u8 *src)
{

  u8 	enc[232];
  u32 	offs = state->pch->game ? 0x33000 : 0x22600;

  rewritechk(src); //rewrite the pokemon's checksum, otherwise bad egg
  encryptPokemon(src, enc);
  memcpy(state->pch->save + offs + 232 * slot, enc, 232);

    if (slot > 929)
    {
      internet_access(1, slot, state, src);
    }

  
  return 0;
}

//switch to a given state
s32	switchState(t_stinf *state, struct s_UIState newst)
{
  state->curState = newst;
  state->curState.initf(state);
  return (0);
}

//Main loop : Executes the current state's functions
//initf : 'init' function
//dispf : 'display' function
//inputf : 'input' function
s32 	startLoop(struct s_pchex *pch)
{
  t_stinf state;

  state.pch = pch;
  //Default state settings
  state.pkmSlot = 0;
  state.login = "";
  state.password = "";
  state.uuid = "0";
  state.reg = 0;
  state.loggedIn = 0;
  state.cont = 1;
  state.inState = 1;
  state.empty = 0;

  //First state is pokemon slot selection
  state.curState = pkmSelectState;
  state.curState.initf(&state);
  memset(&state.cpy, 0, sizeof(state.cpy));

  //main loop
  while (state.cont > 0 && aptMainLoop())
  {
    hidScanInput();
    state.kPressed = hidKeysDown();
    state.curState.dispf(&state);
    state.curState.inputf(&state);

    gfxFlushBuffers();
    gfxSwapBuffers();
    gspWaitForVBlank();
  }
  if (state.cont == -1)
    return 1;
  return 0;
}
